## organicmaps 2025.06.26.3+ds

=== 3party/CMakeLists.txt ===
# Fixes CMake deprecation warning:
# Compatibility with CMake < 3.5 will be removed from a future version of CMake.
set(CMAKE_WARN_DEPRECATED OFF CACHE BOOL "" FORCE)

if (NOT WITH_SYSTEM_PROVIDED_3PARTY)
  # Suppress "Policy CMP0077 is not set: option() honors normal variables"
  # for the freetype, expat and jansson options.
  set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)
  # Suppress "Policy CMP0063 is not set: Honor visibility properties for all target types."
  # for jansson
  set(CMAKE_POLICY_DEFAULT_CMP0063 NEW)

  # Configure expat library.
  set(EXPAT_BUILD_TOOLS OFF)
  set(EXPAT_BUILD_EXAMPLES OFF)
  set(EXPAT_BUILD_TESTS OFF)
  set(EXPAT_BUILD_DOCS OFF)
  set(EXPAT_BUILD_PKGCONFIG OFF)
  set(EXPAT_ENABLE_INSTALL OFF)
  set(EXPAT_SHARED_LIBS OFF)
  set(EXPAT_GE OFF)
  set(EXPAT_DTD OFF)
  set(EXPAT_NS ON)
  add_subdirectory(expat/expat)

  # Configure Jansson library.
  set(JANSSON_BUILD_DOCS OFF)
  set(JANSSON_BUILD_MAN OFF)
  set(JANSSON_EXAMPLES OFF)
  set(JANSSON_INSTALL OFF)
  set(JANSSON_WITHOUT_TESTS ON)
  add_subdirectory(jansson/jansson/)
  target_include_directories(jansson INTERFACE "${PROJECT_BINARY_DIR}/3party/jansson/jansson/include")

  # Add gflags library.
  set(GFLAGS_BUILD_TESTING OFF)
  set(GFLAGS_BUILD_PACKAGING OFF)
  add_subdirectory(gflags)
  target_compile_options(gflags_nothreads_static PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wno-subobject-linkage>)

  # Add pugixml library.
  add_subdirectory(pugixml)

  # Add protobuf library.
  add_subdirectory(protobuf)

  if (NOT PLATFORM_LINUX)
    add_subdirectory(freetype)
    add_subdirectory(icu)
    add_subdirectory(harfbuzz)
  endif()

  add_library(utf8cpp INTERFACE)
  add_library(utf8cpp::utf8cpp ALIAS utf8cpp)
  target_include_directories(utf8cpp INTERFACE "${OMIM_ROOT}/3party/utfcpp/source")
endif()

add_subdirectory(agg)
add_subdirectory(bsdiff-courgette)
add_subdirectory(minizip)
add_subdirectory(open-location-code)
add_subdirectory(opening_hours)
add_subdirectory(stb_image)
add_subdirectory(succinct)

add_subdirectory(vulkan_wrapper)

if (PLATFORM_DESKTOP)
  add_subdirectory(libtess2)

  set(GLFW_BUILD_DOCS OFF CACHE BOOL "")
  set(GLFW_BUILD_EXAMPLES OFF CACHE BOOL "")
  set(GLFW_BUILD_TESTS OFF CACHE BOOL "")
  set(GLFW_INSTALL OFF CACHE BOOL "")
  set(GLFW_VULKAN_STATIC OFF CACHE BOOL "")
  set(GLFW_BUILD_WAYLAND OFF CACHE BOOL "")
  # Disable ARC for glfw and re-enable after it because it's globally set in the root CMakeLists.txt
  set(CMAKE_OBJC_FLAGS "")
  add_subdirectory(glfw)
  set_target_properties(glfw PROPERTIES UNITY_BUILD OFF)
  set_target_properties(glfw PROPERTIES XCODE_ATTRIBUTE_CLANG_ENABLE_OBJC_ARC NO)
  set(CMAKE_OBJC_FLAGS -fobjc-arc)

  add_subdirectory(imgui)
endif()

=== base/CMakeLists.txt ===
project(base)

set(SRC
  # Our code will be recompiled on modification of these headers.
  ../std/boost_container_hash.hpp
  ../std/boost_geometry.hpp
  ../std/glm_gtx_rotate_vector.hpp
  ../std/target_os.hpp
  ../std/windows.hpp
  array_adapters.hpp
  assert.hpp
  atomic_shared_ptr.hpp
  base.cpp
  base.hpp
  beam.hpp
  bidirectional_map.hpp
  bits.hpp
  buffer_vector.hpp
  cache.hpp
  cancellable.cpp
  cancellable.hpp
  checked_cast.hpp
  clustering_map.hpp
  collection_cast.hpp
  control_flow.hpp
  deferred_task.cpp
  deferred_task.hpp
  dfa_helpers.hpp
  exception.cpp
  exception.hpp
  fifo_cache.hpp
  file_name_utils.cpp
  file_name_utils.hpp
  geo_object_id.cpp
  geo_object_id.hpp
  gmtime.cpp
  gmtime.hpp
  internal/message.cpp
  internal/message.hpp
  levenshtein_dfa.cpp
  levenshtein_dfa.hpp
  limited_priority_queue.hpp
  linked_map.hpp
  logging.cpp
  logging.hpp
  lower_case.cpp
  lru_cache.hpp
  macros.hpp
  math.cpp
  math.hpp
  matrix.hpp
  mem_trie.hpp
  newtype.hpp
  normalize_unicode.cpp
  non_intersecting_intervals.hpp
  observer_list.hpp
  pprof.cpp
  pprof.hpp
  random.hpp
  range_iterator.hpp
  ref_counted.hpp
  rolling_hash.hpp
  scope_guard.hpp
  set_operations.hpp
  shared_buffer_manager.cpp
  shared_buffer_manager.hpp
  small_map.hpp
  small_set.hpp
  src_point.cpp
  src_point.hpp
  stats.hpp
  stl_helpers.hpp
  stl_iterator.hpp
  string_utils.cpp
  string_utils.hpp
  strings_bundle.cpp
  strings_bundle.hpp
  suffix_array.cpp
  suffix_array.hpp
  sunrise_sunset.cpp
  sunrise_sunset.hpp
  task_loop.hpp
  thread.cpp
  thread.hpp
  thread_checker.cpp
  thread_checker.hpp
  thread_pool.cpp
  thread_pool.hpp
  thread_pool_computational.hpp
  thread_pool_delayed.cpp
  thread_pool_delayed.hpp
  thread_safe_queue.hpp
  thread_utils.hpp
  threaded_container.cpp
  threaded_container.hpp
  threaded_list.hpp
  timegm.cpp
  timegm.hpp
  timer.cpp
  timer.hpp
  uni_string_dfa.cpp
  uni_string_dfa.hpp
  visitor.hpp
)

omim_add_library(${PROJECT_NAME} ${SRC})

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
target_link_libraries(${PROJECT_NAME} INTERFACE Threads::Threads)
target_link_libraries(${PROJECT_NAME} PUBLIC utf8cpp::utf8cpp)

if (NOT WITH_SYSTEM_PROVIDED_3PARTY)
  target_include_directories(${PROJECT_NAME} PRIVATE "${OMIM_ROOT}/3party/fast_double_parser/include")
endif()

omim_add_test_subdirectory(base_tests)

=== coding/CMakeLists.txt ===
project(coding)

set(SRC
  base64.cpp
  base64.hpp
  bit_streams.hpp
  buffer_reader.hpp
  buffered_file_writer.cpp
  buffered_file_writer.hpp
  bwt.cpp
  bwt.hpp
  bwt_coder.hpp
  byte_stream.hpp
  compressed_bit_vector.cpp
  compressed_bit_vector.hpp
  constants.hpp
  csv_reader.cpp
  csv_reader.hpp
  dd_vector.hpp
  diff.hpp
  elias_coder.hpp
  endianness.hpp
  file_reader.cpp
  file_reader.hpp
  file_sort.hpp
  file_writer.cpp
  file_writer.hpp
  files_container.cpp
  files_container.hpp
  fixed_bits_ddvector.hpp
  geometry_coding.cpp
  geometry_coding.hpp
  hex.cpp
  hex.hpp
  huffman.cpp
  huffman.hpp
  internal/file64_api.hpp
  internal/file_data.cpp
  internal/file_data.hpp
  internal/xmlparser.hpp
  map_uint32_to_val.hpp
  memory_region.hpp
  mmap_reader.cpp
  mmap_reader.hpp
  move_to_front.cpp
  move_to_front.hpp
  parse_xml.hpp
  point_coding.cpp
  point_coding.hpp
  read_write_utils.hpp
  reader.cpp
  reader.hpp
  reader_cache.hpp
  reader_streambuf.cpp
  reader_streambuf.hpp
  reader_wrapper.hpp
  reader_writer_ops.cpp
  reader_writer_ops.hpp
  serdes_binary_header.hpp
  serdes_json.hpp
  sha1.cpp
  sha1.hpp
  simple_dense_coding.cpp
  simple_dense_coding.hpp
  sparse_vector.hpp
  streams.hpp
  streams_common.hpp
  streams_sink.hpp
  string_utf8_multilang.cpp
  string_utf8_multilang.hpp
  succinct_mapper.hpp
  tesselator_decl.hpp
  text_storage.hpp
  traffic.cpp
  traffic.hpp
  transliteration.cpp
  transliteration.hpp
  url.cpp
  url.hpp
  value_opt_string.hpp
  var_record_reader.hpp
  var_serial_vector.hpp
  varint.hpp
  write_to_sink.hpp
  writer.hpp
  zip_creator.cpp
  zip_creator.hpp
  zip_reader.cpp
  zip_reader.hpp
  zlib.cpp
  zlib.hpp
)

omim_add_library(${PROJECT_NAME} ${SRC})

target_link_libraries(${PROJECT_NAME}
  base
  expat::expat
  cppjansson
  succinct
  ICU::uc
  ICU::i18n # For transliteration.
  minizip
  ZLIB::ZLIB
)

omim_add_test_subdirectory(coding_tests)

=== descriptions/CMakeLists.txt ===
project(descriptions)

set(SRC
  header.hpp
  loader.cpp
  loader.hpp
  serdes.hpp
)

omim_add_library(${PROJECT_NAME} ${SRC})

target_link_libraries(${PROJECT_NAME}
  indexer  # MwmHandle
  coding
)

omim_add_test_subdirectory(descriptions_tests)

=== drape/CMakeLists.txt ===
project(drape)

set(DRAPE_TESTABLE_SRC
  attribute_buffer_mutator.cpp
  attribute_buffer_mutator.hpp
  attribute_provider.cpp
  attribute_provider.hpp
  batcher.cpp
  batcher.hpp
  batcher_helpers.cpp
  batcher_helpers.hpp
  binding_info.cpp
  binding_info.hpp
  buffer_base.cpp
  buffer_base.hpp
  color.hpp
  constants.hpp
  cpu_buffer.cpp
  cpu_buffer.hpp
  data_buffer.cpp
  data_buffer.hpp
  data_buffer_impl.hpp
  debug_renderer.hpp
  drape_diagnostics.hpp
  drape_global.hpp
  drape_routine.hpp
  dynamic_texture.hpp
  font_constants.hpp
  font_texture.cpp
  font_texture.hpp
  framebuffer.cpp
  framebuffer.hpp
  gl_constants.cpp
  gl_constants.hpp
  gl_gpu_program.cpp
  gl_gpu_program.hpp
  gl_extensions_list.cpp
  gl_extensions_list.hpp
  gl_functions.hpp
  gl_includes.hpp
  glsl_func.hpp
  glsl_types.hpp
  glyph.hpp
  glyph_manager.cpp
  glyph_manager.hpp
  gpu_buffer.cpp
  gpu_buffer.hpp
  gpu_program.hpp
  graphics_context.hpp
  graphics_context_factory.cpp
  graphics_context_factory.hpp
  hw_texture.cpp
  hw_texture.hpp
  index_buffer.cpp
  index_buffer.hpp
  index_buffer_mutator.cpp
  index_buffer_mutator.hpp
  index_storage.cpp
  index_storage.hpp
  mesh_object.cpp
  mesh_object.hpp
  object_pool.hpp
  oglcontext.cpp
  oglcontext.hpp
  overlay_handle.cpp
  overlay_handle.hpp
  overlay_tree.cpp
  overlay_tree.hpp
  pointers.cpp
  pointers.hpp
  render_bucket.cpp
  render_bucket.hpp
  render_state.cpp
  render_state.hpp
  shader.cpp
  shader.hpp
  static_texture.cpp
  static_texture.hpp
  stipple_pen_resource.cpp
  stipple_pen_resource.hpp
  support_manager.cpp
  support_manager.hpp
  symbols_texture.cpp
  symbols_texture.hpp
  harfbuzz_shaping.cpp
  harfbuzz_shaping.hpp
  texture.cpp
  texture.hpp
  texture_manager.cpp
  texture_manager.hpp
  texture_of_colors.cpp
  texture_of_colors.hpp
  texture_types.hpp
  tm_read_resources.hpp
  uniform_value.cpp
  uniform_value.hpp
  utils/glyph_usage_tracker.cpp
  utils/glyph_usage_tracker.hpp
  utils/gpu_mem_tracker.cpp
  utils/gpu_mem_tracker.hpp
  utils/projection.cpp
  utils/projection.hpp
  utils/vertex_decl.cpp
  utils/vertex_decl.hpp
  vertex_array_buffer.cpp
  vertex_array_buffer.hpp
  viewport.cpp
  viewport.hpp
  visual_scale.hpp
  vulkan/vulkan_base_context.cpp
  vulkan/vulkan_base_context.hpp
  vulkan/vulkan_context_factory.cpp
  vulkan/vulkan_context_factory.hpp
  vulkan/vulkan_gpu_buffer_impl.cpp
  vulkan/vulkan_gpu_buffer_impl.hpp
  vulkan/vulkan_gpu_program.hpp
  vulkan/vulkan_layers.cpp
  vulkan/vulkan_layers.hpp
  vulkan/vulkan_memory_manager.cpp
  vulkan/vulkan_memory_manager.hpp
  vulkan/vulkan_mesh_object_impl.cpp
  vulkan/vulkan_object_manager.cpp
  vulkan/vulkan_object_manager.hpp
  vulkan/vulkan_param_descriptor.cpp
  vulkan/vulkan_param_descriptor.hpp
  vulkan/vulkan_pipeline.cpp
  vulkan/vulkan_pipeline.hpp
  vulkan/vulkan_staging_buffer.cpp
  vulkan/vulkan_staging_buffer.hpp
  vulkan/vulkan_texture.cpp
  vulkan/vulkan_texture.hpp
  vulkan/vulkan_utils.cpp
  vulkan/vulkan_utils.hpp
  vulkan/vulkan_vertex_array_buffer_impl.cpp
)

if (PLATFORM_IPHONE OR PLATFORM_MAC)
  append(DRAPE_TESTABLE_SRC
    metal/metal_base_context.hpp
    metal/metal_base_context.mm
    metal/metal_cleaner.hpp
    metal/metal_cleaner.mm
    metal/metal_gpu_buffer_impl.mm
    metal/metal_gpu_program.hpp
    metal/metal_mesh_object_impl.mm
    metal/metal_states.hpp
    metal/metal_states.mm
    metal/metal_texture.hpp
    metal/metal_texture.mm
    metal/metal_vertex_array_buffer_impl.mm
    metal/render_state_metal.mm
  )
endif()

set(SRC ${DRAPE_TESTABLE_SRC} gl_functions.cpp)

if (PLATFORM_IPHONE)
  append(SRC
    hw_texture_ios.hpp
    hw_texture_ios.mm
  )
endif()

omim_add_library(${PROJECT_NAME} ${SRC})

# Do not include glm's CMakeLists.txt, because it's outdated and not necessary.
target_include_directories(${PROJECT_NAME} PUBLIC ${OMIM_ROOT}/3party/glm)

if (PLATFORM_LINUX OR PLATFORM_WIN)
  find_package(OpenGL)
endif()

if (PLATFORM_MAC)
  set_target_properties(${PROJECT_NAME} PROPERTIES XCODE_ATTRIBUTE_CLANG_ENABLE_OBJC_ARC YES)
endif()

set(DRAPE_LINK_LIBRARIES
  indexer
  platform
  geometry
  coding
  base
  Freetype::Freetype
  vulkan_wrapper
  stb_image
  harfbuzz::harfbuzz
  ICU::i18n
  expat::expat
  $<$<BOOL:${PLATFORM_MAC}>:-framework\ OpenGL>
  $<$<BOOL:${PLATFORM_MAC}>:-framework\ Metal>
  $<$<BOOL:${PLATFORM_LINUX}>:OpenGL::GL>
  $<$<BOOL:${PLATFORM_WIN}>:OpenGL::GL>
)

target_link_libraries(${PROJECT_NAME} ${DRAPE_LINK_LIBRARIES})

omim_add_test_subdirectory(drape_tests)

omim_add_tool_subdirectory(fonts_tool)

=== drape_frontend/CMakeLists.txt ===
project(drape_frontend)

set(SRC
  animation/animation.cpp
  animation/animation.hpp
  animation/arrow_animation.cpp
  animation/arrow_animation.hpp
  animation/base_interpolator.cpp
  animation/base_interpolator.hpp
  animation/follow_animation.cpp
  animation/follow_animation.hpp
  animation/interpolation_holder.cpp
  animation/interpolation_holder.hpp
  animation/interpolations.cpp
  animation/interpolations.hpp
  animation/interpolators.cpp
  animation/interpolators.hpp
  animation/linear_animation.cpp
  animation/linear_animation.hpp
  animation/opacity_animation.cpp
  animation/opacity_animation.hpp
  animation/parallel_animation.cpp
  animation/parallel_animation.hpp
  animation/scale_animation.cpp
  animation/scale_animation.hpp
  animation/sequence_animation.cpp
  animation/sequence_animation.hpp
  animation/show_hide_animation.cpp
  animation/show_hide_animation.hpp
  animation/value_mapping.hpp
  animation_constants.hpp
  animation_system.cpp
  animation_system.hpp
  animation_utils.cpp
  animation_utils.hpp
  apply_feature_functors.cpp
  apply_feature_functors.hpp
  area_shape.cpp
  area_shape.hpp
  arrow3d.cpp
  arrow3d.hpp
  backend_renderer.cpp
  backend_renderer.hpp
  base_renderer.cpp
  base_renderer.hpp
  batcher_bucket.hpp
  batchers_pool.hpp
  circles_pack_shape.cpp
  circles_pack_shape.hpp
  color_constants.cpp
  color_constants.hpp
  colored_symbol_shape.cpp
  colored_symbol_shape.hpp
  custom_features_context.hpp
  debug_rect_renderer.cpp
  debug_rect_renderer.hpp
  drape_api.cpp
  drape_api.hpp
  drape_api_builder.cpp
  drape_api_builder.hpp
  drape_api_renderer.cpp
  drape_api_renderer.hpp
  drape_engine.cpp
  drape_engine.hpp
  drape_engine_params.hpp
  drape_engine_safe_ptr.hpp
  drape_hints.hpp
  drape_notifier.cpp
  drape_notifier.hpp
  drape_measurer.cpp
  drape_measurer.hpp
  engine_context.cpp
  engine_context.hpp
  frame_values.hpp
  frontend_renderer.cpp
  frontend_renderer.hpp
  gps_track_point.hpp
  gps_track_renderer.cpp
  gps_track_renderer.hpp
  gui/choose_position_mark.cpp
  gui/choose_position_mark.hpp
  gui/compass.cpp
  gui/compass.hpp
  gui/copyright_label.cpp
  gui/copyright_label.hpp
  gui/debug_label.cpp
  gui/debug_label.hpp
  gui/drape_gui.cpp
  gui/drape_gui.hpp
  gui/gui_text.cpp
  gui/gui_text.hpp
  gui/layer_render.cpp
  gui/layer_render.hpp
  gui/ruler.cpp
  gui/ruler.hpp
  gui/ruler_helper.cpp
  gui/ruler_helper.hpp
  gui/scale_fps_helper.hpp
  gui/shape.cpp
  gui/shape.hpp
  gui/skin.cpp
  gui/skin.hpp
  kinetic_scroller.cpp
  kinetic_scroller.hpp
  line_shape.cpp
  line_shape.hpp
  line_shape_helper.cpp
  line_shape_helper.hpp
  map_data_provider.cpp
  map_data_provider.hpp
  map_shape.hpp
  message.cpp
  message.hpp
  message_acceptor.cpp
  message_acceptor.hpp
  message_queue.cpp
  message_queue.hpp
  message_subclasses.hpp
  metaline_manager.cpp
  metaline_manager.hpp
  my_position.cpp
  my_position.hpp
  my_position_controller.cpp
  my_position_controller.hpp
  navigator.cpp
  navigator.hpp
  overlay_batcher.cpp
  overlay_batcher.hpp
  overlays_tracker.cpp
  overlays_tracker.hpp
  path_symbol_shape.cpp
  path_symbol_shape.hpp
  path_text_handle.cpp
  path_text_handle.hpp
  path_text_shape.cpp
  path_text_shape.hpp
  poi_symbol_shape.cpp
  poi_symbol_shape.hpp
  postprocess_renderer.cpp
  postprocess_renderer.hpp
  read_manager.cpp
  read_manager.hpp
  read_metaline_task.cpp
  read_metaline_task.hpp
  read_mwm_task.cpp
  read_mwm_task.hpp
  render_group.cpp
  render_group.hpp
  render_node.hpp
  render_state_extension.cpp
  render_state_extension.hpp
  requested_tiles.cpp
  requested_tiles.hpp
  route_builder.cpp
  route_builder.hpp
  route_renderer.cpp
  route_renderer.hpp
  route_shape.cpp
  route_shape.hpp
  rule_drawer.cpp
  rule_drawer.hpp
  scenario_manager.cpp
  scenario_manager.hpp
  screen_animations.cpp
  screen_animations.hpp
  screen_operations.cpp
  screen_operations.hpp
  screen_quad_renderer.cpp
  screen_quad_renderer.hpp
  selection_shape.cpp
  selection_shape.hpp
  selection_shape_generator.cpp
  selection_shape_generator.hpp
  shape_view_params.hpp
  stylist.cpp
  stylist.hpp
  text_handle.cpp
  text_handle.hpp
  text_layout.cpp
  text_layout.hpp
  text_shape.cpp
  text_shape.hpp
  threads_commutator.cpp
  threads_commutator.hpp
  tile_info.cpp
  tile_info.hpp
  tile_key.cpp
  tile_key.hpp
  tile_utils.cpp
  tile_utils.hpp
  traffic_generator.cpp
  traffic_generator.hpp
  traffic_renderer.cpp
  traffic_renderer.hpp
  transit_scheme_builder.cpp
  transit_scheme_builder.hpp
  transit_scheme_renderer.cpp
  transit_scheme_renderer.hpp
  user_event_stream.cpp
  user_event_stream.hpp
  user_mark_generator.cpp
  user_mark_generator.hpp
  user_mark_shapes.cpp
  user_mark_shapes.hpp
  user_marks_provider.cpp
  user_marks_provider.hpp
  visual_params.cpp
  visual_params.hpp
)

omim_add_library(${PROJECT_NAME} ${SRC})

target_link_libraries(${PROJECT_NAME}
  editor
  drape
  indexer
  traffic
  transit
  shaders
)

omim_add_test_subdirectory(drape_frontend_tests)

=== editor/CMakeLists.txt ===
project(editor)

set(SRC
  changeset_wrapper.cpp
  changeset_wrapper.hpp
  config_loader.cpp
  config_loader.hpp
  editable_data_source.hpp
  editable_feature_source.cpp
  editable_feature_source.hpp
  editor_config.cpp
  editor_config.hpp
  editor_notes.cpp
  editor_notes.hpp
  editor_storage.cpp
  editor_storage.hpp
  edits_migration.cpp
  edits_migration.hpp
  feature_matcher.cpp
  feature_matcher.hpp
  new_feature_categories.cpp
  new_feature_categories.hpp
  opening_hours_ui.cpp
  opening_hours_ui.hpp
  osm_auth.cpp
  osm_auth.hpp
  osm_editor.cpp
  osm_editor.hpp
  server_api.cpp
  server_api.hpp
  ui2oh.cpp
  ui2oh.hpp
  xml_feature.cpp
  xml_feature.hpp
  yes_no_unknown.hpp
)

omim_add_library(${PROJECT_NAME} ${SRC})

target_link_libraries(${PROJECT_NAME}
  indexer
  opening_hours
  pugixml
)

omim_add_test_subdirectory(editor_tests)
omim_add_test_subdirectory(editor_tests_support)
omim_add_test_subdirectory(osm_auth_tests)

=== feature_list/CMakeLists.txt ===
project(feature_list_generator)

set(SRC feature_list.cpp)

omim_add_executable(${PROJECT_NAME} ${SRC})

target_link_libraries(${PROJECT_NAME}
  mwm_diff
  generator
  search
  platform
  indexer
)

=== ge0/CMakeLists.txt ===
project(ge0)

set(SRC
  geo_url_parser.cpp
  geo_url_parser.hpp
  parser.cpp
  parser.hpp
  url_generator.cpp
  url_generator.hpp
)

omim_add_library(${PROJECT_NAME} ${SRC})
target_link_libraries(${PROJECT_NAME}
  PUBLIC
    coding

  PRIVATE
    base
    geometry
)

omim_add_test_subdirectory(ge0_tests)

=== generator/CMakeLists.txt ===
project(generator)

set(SRC
  addresses_collector.cpp
  addresses_collector.hpp
  address_enricher.cpp
  address_enricher.hpp
  affiliation.cpp
  affiliation.hpp
  altitude_generator.cpp
  altitude_generator.hpp
  borders.cpp
  borders.hpp
  boundary_postcodes_enricher.cpp
  boundary_postcodes_enricher.hpp
  brands_loader.cpp
  brands_loader.hpp
  camera_info_collector.cpp
  camera_info_collector.hpp
  cells_merger.cpp
  cells_merger.hpp
  centers_table_builder.cpp
  centers_table_builder.hpp
  check_model.cpp
  check_model.hpp
  cities_boundaries_builder.cpp
  cities_boundaries_builder.hpp
  cities_boundaries_checker.cpp
  cities_boundaries_checker.hpp
  cities_ids_builder.cpp
  cities_ids_builder.hpp
  city_roads_generator.cpp
  city_roads_generator.hpp
  cluster_finder.hpp
  coastlines_generator.cpp
  coastlines_generator.hpp
  collection_base.hpp
  collector_boundary_postcode.cpp
  collector_boundary_postcode.hpp
  collector_building_parts.cpp
  collector_building_parts.hpp
  collector_camera.cpp
  collector_camera.hpp
  collector_collection.cpp
  collector_collection.hpp
  collector_interface.hpp
  collector_mini_roundabout.cpp
  collector_mini_roundabout.hpp
  collector_routing_city_boundaries.cpp
  collector_routing_city_boundaries.hpp
  collector_tag.cpp
  collector_tag.hpp
#  complex_loader.cpp
#  complex_loader.hpp
  composite_id.cpp
  composite_id.hpp
  cross_mwm_osm_ways_collector.cpp
  cross_mwm_osm_ways_collector.hpp
  descriptions_section_builder.cpp
  descriptions_section_builder.hpp
  dumper.cpp
  dumper.hpp
  factory_utils.hpp
  feature_builder.cpp
  feature_builder.hpp
  feature_emitter_iface.hpp
  feature_generator.cpp
  feature_generator.hpp
  feature_helpers.cpp
  feature_helpers.hpp
  feature_maker.cpp
  feature_maker.hpp
  feature_maker_base.cpp
  feature_maker_base.hpp
  feature_merger.cpp
  feature_merger.hpp
  feature_processing_layers.cpp
  feature_processing_layers.hpp
  feature_sorter.cpp
  feature_sorter.hpp
  features_processing_helpers.hpp
  filter_collection.cpp
  filter_collection.hpp
#  filter_complex.cpp
#  filter_complex.hpp
  filter_elements.cpp
  filter_elements.hpp
  filter_interface.hpp
  filter_planet.cpp
  filter_planet.hpp
  filter_roads.cpp
  filter_roads.hpp
  filter_world.cpp
  filter_world.hpp
  final_processor_cities.cpp
  final_processor_cities.hpp
  final_processor_coastline.cpp
  final_processor_coastline.hpp
#  final_processor_complex.cpp
#  final_processor_complex.hpp
  final_processor_country.cpp
  final_processor_country.hpp
  final_processor_interface.hpp
  final_processor_utils.cpp
  final_processor_utils.hpp
  final_processor_world.cpp
  final_processor_world.hpp
  gen_mwm_info.cpp
  gen_mwm_info.hpp
  generate_info.hpp
  geometry_holder.hpp
#  hierarchy.cpp
#  hierarchy.hpp
#  hierarchy_entry.cpp
#  hierarchy_entry.hpp
  holes.cpp
  holes.hpp
  intermediate_data.cpp
  intermediate_data.hpp
  intermediate_elements.hpp
  isolines_generator.cpp
  isolines_generator.hpp
  isolines_section_builder.cpp
  isolines_section_builder.hpp
  maxspeeds_builder.cpp
  maxspeeds_builder.hpp
  maxspeeds_collector.cpp
  maxspeeds_collector.hpp
  maxspeeds_parser.cpp
  maxspeeds_parser.hpp
  metalines_builder.cpp
  metalines_builder.hpp
  mini_roundabout_info.cpp
  mini_roundabout_info.hpp
  mini_roundabout_transformer.cpp
  mini_roundabout_transformer.hpp
  node_mixer.cpp
  node_mixer.hpp
  osm2meta.cpp
  osm2meta.hpp
  osm2type.cpp
  osm2type.hpp
  osm_element.cpp
  osm_element.hpp
  osm_element_helpers.cpp
  osm_element_helpers.hpp
  osm_o5m_source.hpp
  osm_source.cpp
  osm_xml_source.hpp
  place_processor.cpp
  place_processor.hpp
  platform_helpers.cpp
  platform_helpers.hpp
  popular_places_section_builder.cpp
  popular_places_section_builder.hpp
  postcode_points_builder.cpp
  postcode_points_builder.hpp
  processor_coastline.cpp
  processor_coastline.hpp
#  processor_complex.cpp
#  processor_complex.hpp
  processor_country.cpp
  processor_country.hpp
  processor_factory.hpp
  processor_interface.hpp
  processor_noop.hpp
#  processor_simple.cpp
#  processor_simple.hpp
  processor_world.cpp
  processor_world.hpp
  raw_generator.cpp
  raw_generator.hpp
  raw_generator_writer.cpp
  raw_generator_writer.hpp
  region_meta.cpp
  region_meta.hpp
  relation_tags.cpp
  relation_tags.hpp
  relation_tags_enricher.cpp
  relation_tags_enricher.hpp
  restriction_collector.cpp
  restriction_collector.hpp
  restriction_generator.cpp
  restriction_generator.hpp
  restriction_writer.cpp
  restriction_writer.hpp
  road_access_generator.cpp
  road_access_generator.hpp
  routing_city_boundaries_processor.cpp
  routing_city_boundaries_processor.hpp
  routing_helpers.cpp
  routing_helpers.hpp
  routing_index_generator.cpp
  routing_index_generator.hpp
  routing_world_roads_generator.cpp
  routing_world_roads_generator.hpp
  search_index_builder.cpp
  search_index_builder.hpp
  srtm_parser.cpp
  srtm_parser.hpp
  statistics.cpp
  statistics.hpp
  tag_admixer.hpp
  tesselator.cpp
  tesselator.hpp
  towns_dumper.cpp
  towns_dumper.hpp
  traffic_generator.cpp
  traffic_generator.hpp
  transit_generator.cpp
  transit_generator.hpp
  transit_generator_experimental.cpp
  transit_generator_experimental.hpp
  translator.cpp
  translator.hpp
  translator_coastline.cpp
  translator_coastline.hpp
  translator_collection.cpp
  translator_collection.hpp
#  translator_complex.cpp
#  translator_complex.hpp
  translator_country.cpp
  translator_country.hpp
  translator_factory.hpp
  translator_interface.hpp
  translator_world.cpp
  translator_world.hpp
  translators_pool.cpp
  translators_pool.hpp
  unpack_mwm.cpp
  unpack_mwm.hpp
  utils.cpp
  utils.hpp
  ways_merger.cpp
  ways_merger.hpp
  way_nodes_mapper.hpp
  wiki_url_dumper.cpp
  wiki_url_dumper.hpp
  water_boundary_checker.hpp
  world_map_generator.hpp
)

omim_add_library(${PROJECT_NAME} ${SRC})

target_link_libraries(${PROJECT_NAME}
  transit
  search
  routing
  storage
  descriptions
  indexer
  cppjansson
  expat::expat
  tess2
  $<$<BOOL:CMAKE_DL_LIBS>:${CMAKE_DL_LIBS}>  # dladdr from boost::stacktrace
)

# Disable unity build to avoid boost::geometry macro linker errors.
set_source_files_properties(
  affiliation.cpp
  final_processor_country.cpp
  hierarchy.cpp
  PROPERTIES SKIP_UNITY_BUILD_INCLUSION TRUE
)

if (NOT (SKIP_TOOLS AND SKIP_TESTS))
  # Used in both tests and some tools.
  add_subdirectory(generator_tests_support)
endif()
omim_add_test_subdirectory(generator_tests)
omim_add_test_subdirectory(generator_integration_tests)

omim_add_tool_subdirectory(generator_tool)
#omim_add_tool_subdirectory(complex_generator)
omim_add_tool_subdirectory(feature_segments_checker)
omim_add_tool_subdirectory(srtm_coverage_checker)
add_subdirectory(world_roads_builder)
add_subdirectory(address_parser)

=== geometry/CMakeLists.txt ===
project(geometry)

set(SRC
  algorithm.cpp
  algorithm.hpp
  angles.cpp
  angles.hpp
  any_rect2d.hpp
  area_on_earth.cpp
  area_on_earth.hpp
  avg_vector.hpp
  bounding_box.cpp
  bounding_box.hpp
  calipers_box.cpp
  calipers_box.hpp
  cellid.hpp
  circle_on_earth.cpp
  circle_on_earth.hpp
  clipping.cpp
  clipping.hpp
  convex_hull.cpp
  convex_hull.hpp
  covering.hpp
  covering_utils.hpp
  diamond_box.cpp
  diamond_box.hpp
  distance_on_sphere.cpp
  distance_on_sphere.hpp
  latlon.cpp
  latlon.hpp
  line2d.cpp
  line2d.hpp
  mercator.cpp
  mercator.hpp
  meter.hpp
  nearby_points_sweeper.cpp
  nearby_points_sweeper.hpp
  oblate_spheroid.cpp
  oblate_spheroid.hpp
  packer.cpp
  packer.hpp
  parametrized_segment.hpp
  point2d.hpp
  point3d.hpp
  point_with_altitude.cpp
  point_with_altitude.hpp
  polygon.hpp
  intersection_score.hpp
  polyline2d.hpp
  rect2d.hpp
  rect_intersect.hpp
  region2d.hpp
  robust_orientation.cpp
  robust_orientation.hpp
  screenbase.cpp
  screenbase.hpp
  segment2d.cpp
  segment2d.hpp
  simplification.hpp
  smoothing.cpp
  smoothing.hpp
  spline.cpp
  spline.hpp
  transformations.hpp
  tree4d.hpp
  triangle2d.cpp
  triangle2d.hpp
)

if (NOT PLATFORM_IPHONE AND NOT PLATFORM_ANDROID)
  append(SRC
    region2d/binary_operators.cpp
    region2d/binary_operators.hpp
    region2d/boost_concept.hpp
  )
endif()

omim_add_library(${PROJECT_NAME} ${SRC})

target_link_libraries(${PROJECT_NAME} base)

omim_add_test_subdirectory(geometry_tests)

=== indexer/CMakeLists.txt ===
project(indexer)

set(SRC
  altitude_loader.cpp
  altitude_loader.hpp
  brands_holder.cpp
  brands_holder.hpp
  caching_rank_table_loader.cpp
  caching_rank_table_loader.hpp
  categories_holder.cpp
  categories_holder.hpp
  categories_holder_loader.cpp
  categories_index.cpp
  categories_index.hpp
  cell_coverer.hpp
  cell_id.hpp
  cell_value_pair.hpp
  centers_table.cpp
  centers_table.hpp
  cities_boundaries_serdes.hpp
  city_boundary.hpp
  classificator.cpp
  classificator.hpp
  classificator_loader.cpp
  classificator_loader.hpp
  complex/serdes.cpp
  complex/serdes.hpp
  complex/serdes_utils.hpp
  complex/tree_node.hpp
  cuisines.cpp
  cuisines.hpp
  custom_keyvalue.cpp
  custom_keyvalue.hpp
  data_factory.cpp
  data_factory.hpp
  data_header.cpp
  data_header.hpp
  data_source.cpp
  data_source.hpp
  data_source_helpers.cpp
  data_source_helpers.hpp
  displacement_manager.hpp
  drawing_rule_def.cpp
  drawing_rule_def.hpp
  drawing_rules.cpp
  drawing_rules.hpp
  drules_include.hpp
  drules_selector.cpp
  drules_selector.hpp
  drules_selector_parser.cpp
  drules_selector_parser.hpp
  drules_struct.pb.cc
  drules_struct.pb.h
  edit_journal.cpp
  edit_journal.hpp
  editable_map_object.cpp
  editable_map_object.hpp
  fake_feature_ids.cpp
  fake_feature_ids.hpp
  feature.cpp
  feature.hpp
  feature_algo.cpp
  feature_algo.hpp
  feature_altitude.hpp
  feature_covering.cpp
  feature_covering.hpp
  feature_data.cpp
  feature_data.hpp
  feature_decl.cpp
  feature_decl.hpp
  feature_impl.cpp
  feature_impl.hpp
  feature_meta.cpp
  feature_meta.hpp
  feature_processor.hpp
  feature_source.cpp
  feature_source.hpp
  feature_to_osm.cpp
  feature_to_osm.hpp
  feature_utils.cpp
  feature_utils.hpp
  feature_visibility.cpp
  feature_visibility.hpp
  features_offsets_table.cpp
  features_offsets_table.hpp
  features_vector.cpp
  features_vector.hpp
  ftraits.hpp
  ftypes_matcher.cpp
  ftypes_matcher.hpp
  house_to_street_iface.hpp
  index_builder.cpp
  index_builder.hpp
  interval_index.hpp
  interval_index_builder.hpp
  isolines_info.cpp
  isolines_info.hpp
  map_object.cpp
  map_object.hpp
  map_style.cpp
  map_style.hpp
  map_style_reader.cpp
  map_style_reader.hpp
  metadata_serdes.cpp
  metadata_serdes.hpp
  mwm_set.cpp
  mwm_set.hpp
  postcodes_matcher.cpp  # it's in indexer due to editor which is in indexer and depends on postcodes_marcher
  postcodes_matcher.hpp  # it's in indexer due to editor which is in indexer and depends on postcodes_marcher
  rank_table.cpp
  rank_table.hpp
  road_shields_parser.cpp
  road_shields_parser.hpp
  scale_index.hpp
  scale_index_builder.hpp
  scales.cpp
  scales.hpp
  scales_patch.hpp
  search_delimiters.cpp    # it's in indexer because of CategoriesHolder dependency.
  search_delimiters.hpp    # it's in indexer because of CategoriesHolder dependency.
  search_string_utils.cpp  # it's in indexer because of CategoriesHolder dependency.
  search_string_utils.hpp  # it's in indexer because of CategoriesHolder dependency.
  shared_load_info.cpp
  shared_load_info.hpp
  string_set.hpp
  string_slice.cpp
  string_slice.hpp
  succinct_trie_builder.hpp
  succinct_trie_reader.hpp
  transliteration_loader.cpp
  transliteration_loader.hpp
  tree_structure.hpp
  trie.hpp
  trie_builder.hpp
  trie_reader.hpp
  types_mapping.cpp
  types_mapping.hpp
  unique_index.hpp
  utils.cpp
  utils.hpp
  validate_and_format_contacts.cpp
  validate_and_format_contacts.hpp
)

set(OTHER_FILES drules_struct.proto)

# Disable warnings.
set_source_files_properties(drules_struct.pb.cc PROPERTIES COMPILE_FLAGS
  "$<$<CXX_COMPILER_ID:AppleClang,Clang>:-Wno-shorten-64-to-32> $<$<CXX_COMPILER_ID:GNU>:-Wno-deprecated-declarations>"
)

file(COPY ${OTHER_FILES} DESTINATION ${CMAKE_BINARY_DIR})

omim_add_library(${PROJECT_NAME} ${SRC})

target_link_libraries(${PROJECT_NAME}
  search  # search::DummyRankTable in CachingRankTableLoader
  platform
  geometry
  protobuf
  coding
)

omim_add_test_subdirectory(indexer_tests)

=== debian/control ===
Source: organicmaps
Section: x11
Priority: optional
Maintainer: Federico Ceratto <federico@debian.org>
Uploaders: Jochen Sprickerhof <jspricke@debian.org>
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libagg2-dev,
 libboost-dev,
 libexpat1-dev,
 libfastobj-dev,
 libflathashmap-dev,
 libfreetype-dev,
 libgflags-dev,
 libglm-dev,
 libharfbuzz-dev,
 libicu-dev,
 libjansson-dev,
 libkdtree++-dev,
 libminizip-dev,
 libprotobuf-dev,
 libpugixml-dev,
 libqt6svg6,
 libstb-dev,
 libutfcpp-dev,
 optipng,
 protobuf-compiler,
 python3-mapcss,
 python3-protobuf,
 qt6-base-dev,
 qt6-positioning-dev,
 qt6-svg-dev,
 curl <!nocheck>,
 xauth,
 xvfb,
Standards-Version: 4.7.2
Homepage: https://organicmaps.app/
Vcs-Browser: https://salsa.debian.org/debian/organicmaps
Vcs-Git: https://salsa.debian.org/debian/organicmaps.git
Description: offline maps with routing ability
 Organic Maps is a map application for travelers, tourists, hikers,
 and cyclists based on top of crowd-sourced OpenStreetMap data.
 It is privacy-focused and can be used without an Internet connection.
 It provides navigation for pedestrians, public transport, cycling
 and driving.

Package: organicmaps
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 organicmaps-data,
Description: ${source:Synopsis} (executable)
 ${source:Extended-Description}
 .
 This package contains the OMaps executable.

Package: organicmaps-data
Architecture: all
Depends:
 ${misc:Depends},
Description: ${source:Synopsis} (data)
 ${source:Extended-Description}
 .
 This package contains architecture independent data.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

execute_before_dh_auto_configure:
	tools/unix/generate_proto.sh
	xvfb-run tools/unix/generate_symbols.sh
	tools/unix/generate_drules.sh

override_dh_auto_configure:
	dh_auto_configure --
	 -DWITH_SYSTEM_PROVIDED_3PARTY=ON

execute_after_dh_auto_build:
	HOME=/tmp obj-$(DEB_HOST_GNU_TYPE)/generator_tool -generate_packed_borders

=== debian/watch ===
version=4

opts=\
repacksuffix=+ds,\
repack,compression=xz,\
filenamemangle=s/(\d+\.\d+\.\d+.\d+)-android\.tar\.gz/organicmaps-$1.tar.gz/,\
dversionmangle=auto,\
uversionmangle=s/-/./ \
 https://github.com/organicmaps/organicmaps/tags .*/tags/(\d+\.\d+\.\d+-\d+)-android.tar.gz
